// Format.cpp : implementation file
//

#include "stdafx.h"
#include "FontDemo.h"
#include "Format.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFormat dialog


CFormat::CFormat(CWnd* pParent /*=NULL*/)
   : CDialog(CFormat::IDD, pParent)
{
   //{{AFX_DATA_INIT(CFormat)
   m_Bold = FALSE;
   m_Italic = FALSE;
   m_Underline = FALSE;
   m_Justify = -1;
   m_Pitch = -1;
   m_Spacing = 0;
   //}}AFX_DATA_INIT
}


void CFormat::DoDataExchange(CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   //{{AFX_DATA_MAP(CFormat)
   DDX_Control(pDX, IDC_SPACING, m_SpacingEdit);
   DDX_Check(pDX, IDC_BOLD, m_Bold);
   DDX_Check(pDX, IDC_ITALIC, m_Italic);
   DDX_Check(pDX, IDC_UNDERLINE, m_Underline);
   DDX_Radio(pDX, IDC_LEFT, m_Justify);
   DDX_Radio(pDX, IDC_VARIABLE, m_Pitch);
   DDX_Text(pDX, IDC_SPACING, m_Spacing);
   DDV_MinMaxInt(pDX, m_Spacing, 1, 3);
   //}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFormat, CDialog)
   //{{AFX_MSG_MAP(CFormat)
   ON_WM_PAINT()
   ON_BN_CLICKED(IDC_BOLD, OnBold)
   ON_BN_CLICKED(IDC_CENTER, OnCenter)
   ON_BN_CLICKED(IDC_FIXED, OnFixed)
   ON_BN_CLICKED(IDC_ITALIC, OnItalic)
   ON_BN_CLICKED(IDC_LEFT, OnLeft)
   ON_BN_CLICKED(IDC_RIGHT, OnRight)
   ON_BN_CLICKED(IDC_UNDERLINE, OnUnderline)
   ON_BN_CLICKED(IDC_VARIABLE, OnVariable)
   ON_EN_CHANGE(IDC_SPACING, OnChangeSpacing)
   //}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFormat message handlers

BOOL CFormat::OnInitDialog() 
{
   CDialog::OnInitDialog();
   
   // TODO: Add extra initialization here
   
   GetDlgItem (IDC_SAMPLE)->GetWindowRect (&m_RectSample);   
   ScreenToClient (&m_RectSample);

   m_SpacingEdit.LimitText (1);         

   return TRUE;  // return TRUE unless you set the focus to a control
                 // EXCEPTION: OCX Property Pages should return FALSE
}

void CFormat::OnPaint() 
{
   CPaintDC dc(this); // device context for painting
   
   // TODO: Add your message handler code here
   CFont Font;
   LOGFONT LF;
   int LineHeight;
   CFont *PtrOldFont;
   int X, Y;

   // fill LF with the features of a standard system font:
   CFont TempFont;
   if (m_Pitch == PITCH_VARIABLE)  
      TempFont.CreateStockObject (SYSTEM_FONT);
   else
      TempFont.CreateStockObject (SYSTEM_FIXED_FONT);
   TempFont.GetObject (sizeof (LOGFONT), &LF);

   // now customize lfWeight, lfItalic, and lfUnderline fields:
   if (m_Bold)
      LF.lfWeight = FW_BOLD;
   if (m_Italic)
      LF.lfItalic = 1;
   if (m_Underline)
      LF.lfUnderline = 1;

   // create and select font:
   Font.CreateFontIndirect (&LF);
   PtrOldFont = dc.SelectObject (&Font);
   
   // set justification:
   switch (m_Justify)
      {
      case JUSTIFY_LEFT:
         dc.SetTextAlign (TA_LEFT);
         X = m_RectSample.left + 5;      
         break;
      case JUSTIFY_CENTER:
         dc.SetTextAlign (TA_CENTER);
         X = (m_RectSample.left + m_RectSample.right) / 2;
         break;
      case JUSTIFY_RIGHT:
         dc.SetTextAlign (TA_RIGHT);
         X = m_RectSample.right - 5;      
         break;         
      }

   // set background mode:
   dc.SetBkMode (TRANSPARENT);

   // draw lines of text:
   LineHeight = LF.lfHeight * m_Spacing;
   Y = m_RectSample.top + 15;
   dc.TextOut (X, Y, "AaBbCdDdEeFf");
   Y += LineHeight;
   dc.TextOut (X, Y, "GhHhIiJjKkLl");
   Y += LineHeight;
   dc.TextOut (X, Y, "MmNnOoPpQqRr");
   
   // unselect font:
   dc.SelectObject (PtrOldFont);
   
   // Do not call CDialog::OnPaint() for painting messages
}

void CFormat::OnBold() 
{
   // TODO: Add your control notification handler code here
   m_Bold = !m_Bold;
   InvalidateRect (&m_RectSample);
   UpdateWindow ();
}

void CFormat::OnCenter() 
{
   // TODO: Add your control notification handler code here
   if (IsDlgButtonChecked (IDC_CENTER))
      {
      m_Justify = JUSTIFY_CENTER;
      InvalidateRect (&m_RectSample);
      UpdateWindow ();
      }
}

void CFormat::OnFixed() 
{
   // TODO: Add your control notification handler code here
   if (IsDlgButtonChecked (IDC_FIXED))
      {   
      m_Pitch = PITCH_FIXED;
      InvalidateRect (&m_RectSample);
      UpdateWindow ();
      }
}

void CFormat::OnItalic() 
{
   // TODO: Add your control notification handler code here
   m_Italic = !m_Italic;
   InvalidateRect (&m_RectSample);
   UpdateWindow ();
}

void CFormat::OnLeft() 
{
   // TODO: Add your control notification handler code here
   if (IsDlgButtonChecked (IDC_LEFT))
      {
      m_Justify = JUSTIFY_LEFT;
      InvalidateRect (&m_RectSample);
      UpdateWindow ();
      }
}

void CFormat::OnRight() 
{
   // TODO: Add your control notification handler code here
   if (IsDlgButtonChecked (IDC_RIGHT))
      {
      m_Justify = JUSTIFY_RIGHT;
      InvalidateRect (&m_RectSample);
      UpdateWindow ();
      }
}

void CFormat::OnUnderline() 
{
   // TODO: Add your control notification handler code here
   m_Underline = !m_Underline;
   InvalidateRect (&m_RectSample);
   UpdateWindow ();
}

void CFormat::OnVariable() 
{
   // TODO: Add your control notification handler code here
   if (IsDlgButtonChecked (IDC_VARIABLE))
      {   
      m_Pitch = PITCH_VARIABLE;
      InvalidateRect (&m_RectSample);
      UpdateWindow ();
      }
}

void CFormat::OnChangeSpacing() 
{
   // TODO: Add your control notification handler code here
   int Temp;
   Temp = (int)GetDlgItemInt (IDC_SPACING);
   if (Temp > 0 && Temp < 4)
      {
      m_Spacing = Temp;
      InvalidateRect (&m_RectSample);
      UpdateWindow ();
      }
}
