// SrvrItem.cpp : implementation of the CServDemoSrvrItem class
//

#include "stdafx.h"
#include "ServDemo.h"

#include "ServDDoc.h"
#include "SrvrItem.h"
#include "ServDeVw.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CServDemoSrvrItem implementation

IMPLEMENT_DYNAMIC(CServDemoSrvrItem, COleServerItem)

CServDemoSrvrItem::CServDemoSrvrItem(CServDemoDoc* pContainerDoc)
   : COleServerItem(pContainerDoc, TRUE)
{
   // TODO: add one-time construction code here
   //  (eg, adding additional clipboard formats to the item's data source)
}

CServDemoSrvrItem::~CServDemoSrvrItem()
{
   // TODO: add cleanup code here
}

void CServDemoSrvrItem::Serialize(CArchive& ar)
{
   // CServDemoSrvrItem::Serialize will be called by the framework if
   //  the item is copied to the clipboard.  This can happen automatically
   //  through the OLE callback OnGetClipboardData.  A good default for
   //  the embedded item is simply to delegate to the document's Serialize
   //  function.  If you support links, then you will want to serialize
   //  just a portion of the document.

   if (!IsLinkedItem())
   {
      CServDemoDoc* pDoc = GetDocument();
      ASSERT_VALID(pDoc);
      pDoc->Serialize(ar);
   }
}

BOOL CServDemoSrvrItem::OnGetExtent(DVASPECT dwDrawAspect, CSize& rSize)
{
   // Most applications, like this one, only handle drawing the content
   //  aspect of the item.  If you wish to support other aspects, such
   //  as DVASPECT_THUMBNAIL (by overriding OnDrawEx), then this
   //  implementation of OnGetExtent should be modified to handle the
   //  additional aspect(s).

   if (dwDrawAspect != DVASPECT_CONTENT)
      return COleServerItem::OnGetExtent(dwDrawAspect, rSize);

   // CServDemoSrvrItem::OnGetExtent is called to get the extent in
   //  HIMETRIC units of the entire item.  The default implementation
   //  here simply returns a hard-coded number of units.

   CServDemoDoc* pDoc = GetDocument();
   ASSERT_VALID(pDoc);

   // TODO: replace this arbitrary size

   rSize = CSize(3000, 3000);   // 3000 x 3000 HIMETRIC units

   return TRUE;
}

BOOL CServDemoSrvrItem::OnDraw(CDC* pDC, CSize& rSize)
{
   CServDemoDoc* pDoc = GetDocument();
   ASSERT_VALID(pDoc);

   // TODO: set mapping mode and extent
   //  (The extent is usually the same as the size returned from OnGetExtent)
   pDC->SetMapMode(MM_ANISOTROPIC);
   pDC->SetWindowOrg(0,0);
   POSITION Pos = pDoc->GetFirstViewPosition ();
   CServDemoView *PCServDemoView = (CServDemoView *)pDoc->GetNextView (Pos);
   pDC->SetWindowExt(PCServDemoView->m_ViewSize.cx,  // replaces the AppWizard
      PCServDemoView->m_ViewSize.cy);                // call to SetWindowExtent

   // TODO: add drawing code here.  Optionally, fill in the HIMETRIC extent.
   //  All drawing takes place in the metafile device context (pDC).

   // same code as in CServDemoView::OnDraw:
   int Index = pDoc->GetNumLines ();
   while (Index--)
      pDoc->GetLine (Index)->Draw (pDC);      

   return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CServDemoSrvrItem diagnostics

#ifdef _DEBUG
void CServDemoSrvrItem::AssertValid() const
{
   COleServerItem::AssertValid();
}

void CServDemoSrvrItem::Dump(CDumpContext& dc) const
{
   COleServerItem::Dump(dc);
}
#endif

/////////////////////////////////////////////////////////////////////////////
